<?php

namespace NoccyLabs\React\Http\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Promise\PromiseInterface;

class ErrorHandlingMiddleware
{
    public function __construct()
    {
        
    }

    public function __invoke(ServerRequestInterface $request, ?callable $next = null): ResponseInterface|PromiseInterface
    {
        try {
            return $next($request);
        } catch (\Throwable $t) {
            return Response::plaintext((string)$t)->withStatus(500);
        }
    }
}