<?php

namespace NoccyLabs\React\Http\Routing;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Promise\PromiseInterface;

class RequestHandler
{
    public function __construct()
    {
        
    }

    public function __invoke(ServerRequestInterface $request, ?callable $next = null): ResponseInterface|PromiseInterface
    {
        $route = $request->getAttribute("route");
        $handler = $request->getAttribute("handler");
        $params = $request->getAttribute("route-data");

        if ($route && is_callable($handler)) {
            $result = $handler($request, ...$params);
            return $result;
        }

        if (is_callable($next))
            return $next($request);

        return Response::plaintext("Not found")->withStatus(404);
    }
}