<?php

namespace NoccyLabs\React\Http\Security;

interface UserManagerInterface
{
    /**
     * Get user by user id
     *
     * @param int $userId
     * @return UserInterface
     * @throws UserNotFoundException if the user can not be found
     * @throws InvalidCredentialsException if the credentials are invalid
     */
    public function getUser(int $userId): UserInterface;

    /**
     * Get user by username
     *
     * @param string $username
     * @return UserInterface
     * @throws UserNotFoundException if the user can not be found
     * @throws InvalidCredentialsException if the credentials are invalid
     */
    public function getUserByUsername(string $username): UserInterface;

    /**
     * Get user by active token
     *
     * @param string $token
     * @return UserInterface
     * @throws UserNotFoundException if the user can not be found
     * @throws InvalidCredentialsException if the credentials are invalid
     */
    public function getUserByToken(string $token): UserInterface;
}

